Sign in

Quickstart - Get started with a Quill text editor using Liveblocks and JavaScript

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your JavaScript application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and Quill

    Every Liveblocks package should use the same version.

    Terminal
    npm install @liveblocks/client @liveblocks/yjs yjs quill quill-cursors y-quill
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    Terminal
    npx create-liveblocks-app@latest --init --framework javascript
  3. Create an HTML element

    <div id="editor"></div>
  4. Set up your collaborative Quill text editor

    app.js
    import { createClient } from "@liveblocks/client";import { getYjsProviderForRoom } from "@liveblocks/yjs";import * as Y from "yjs";import Quill from "quill";import { QuillBinding } from "y-quill";import QuillCursors from "quill-cursors";
    // Set up Liveblocks clientconst client = createClient({ publicApiKey: "",});
    // Enter a multiplayer roomconst { room, leave } = client.enterRoom("my-room");
    // Set up Yjs document, shared text, and Liveblocks Yjs providerconst yProvider = getYjsProviderForRoom(room);const yDoc = yProvider.getYDoc();const yText = yDoc.getText("quill");
    // Attach cursors pluginQuill.register("modules/cursors", QuillCursors);
    // Set up Quill editor and modulesconst parent = document.querySelector("#editor");const quill = new Quill(parent, { placeholder: "Start collaborating…", theme: "snow", modules: { cursors: true, toolbar: [ [{ header: [1, 2, false] }], ["bold", "italic", "underline"], ["code-block"], ], history: { // Local undo shouldn’t undo changes made by other users userOnly: true, }, },});
    // Attach Yjs to Quillconst binding = new QuillBinding(yText, quill, yProvider.awareness);
  5. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative Quill text editor inside your JavaScript application.

Sign in

Quickstart - Get started with a Quill text editor using Liveblocks and React

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your React application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and Quill

    Every Liveblocks package should use the same version.

    Terminal
    npm install @liveblocks/client @liveblocks/react @liveblocks/yjs yjs quill quill-cursors react-quill y-quill
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    Terminal
    npx create-liveblocks-app@latest --init --framework react
  3. Set up the Liveblocks client

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate, and to create a realtime experience, multiple users must be connected to the same room. Set up a Liveblocks client with LiveblocksProvider, and join a room with RoomProvider.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> {/* ... */} </RoomProvider> </LiveblocksProvider> );}
  4. Join a Liveblocks room

    After setting up the room, you can add collaborative components inside it, using ClientSideSuspense to add loading spinners to your app.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider, ClientSideSuspense,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> <ClientSideSuspense fallback={<div>Loading…</div>}> <Editor /> </ClientSideSuspense> </RoomProvider> </LiveblocksProvider> );}
  5. Set up the collaborative Quill text editor

    Now that we set up Liveblocks, we can start integrating Quill and Yjs in the Editor.tsx file. To make the editor collaborative, we can rely on QuillBinding and QuillCursors from y-quill and quill-cursors.

    Editor.tsx
    "use client";
    import Quill from "quill";import ReactQuill from "react-quill";import QuillCursors from "quill-cursors";import { QuillBinding } from "y-quill";import * as Y from "yjs";import { getYjsProviderForRoom } from "@liveblocks/yjs";import { useRoom } from "@/liveblocks.config";import { useCallback, useEffect, useRef, useState } from "react";
    Quill.register("modules/cursors", QuillCursors);
    // Collaborative text editor with simple rich text, live cursors, and live avatarsexport function CollaborativeEditor() { const room = useRoom(); const yProvider = getYjsProviderForRoom(room); const yDoc = yProvider.getYDoc(); const yText = yDoc.getText("quill");
    return <QuillEditor yText={yText} provider={yProvider} />;}
    type EditorProps = { yText: Y.Text; provider: any;};
    function QuillEditor({ yText, provider }: EditorProps) { const reactQuillRef = useRef<ReactQuill>(null);
    // Set up Yjs and Quill useEffect(() => { let quill; let binding: QuillBinding;
    if (!reactQuillRef.current) { return; }
    quill = reactQuillRef.current.getEditor(); binding = new QuillBinding(yText, quill, provider.awareness); return () => { binding?.destroy?.(); }; }, [yText, provider]);
    return ( <ReactQuill placeholder="Start typing here…" ref={reactQuillRef} theme="snow" modules={{ cursors: true, history: { // Local undo shouldn't undo changes from remote users userOnly: true, }, }} /> );}
  6. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative Quill text editor inside your React application.


Examples using Quill

Sign in

Quickstart - Get started with a Quill text editor using Liveblocks and Vue.js

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your Vue.js application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and Quill

    Every Liveblocks package should use the same version.

    Terminal
    npm install @liveblocks/client @liveblocks/yjs yjs quill quill-cursors y-quill
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    Terminal
    npx create-liveblocks-app@latest --init --framework javascript
  3. Set up your collaborative Quill text editor

    Editor.vue
    <script setup>import { ref, onMounted, onUnmounted } from "vue";import { createClient } from "@liveblocks/client";import { getYjsProviderForRoom } from "@liveblocks/yjs";import * as Y from "yjs";import Quill from "quill";import { QuillBinding } from "y-quill";import QuillCursors from "quill-cursors";
    const element = ref(null);const binding = ref(null);const leave = ref(null);
    // Set up Liveblocks clientconst client = createClient({ publicApiKey: "",});
    // Enter a multiplayer roomconst info = client.enterRoom("my-room");const room = info.room;leave.value = info.leave;
    // Set up Yjs document, shared text, and Liveblocks Yjs providerconst yProvider = getYjsProviderForRoom(room);const yDoc = yProvider.getYDoc();const yText = yDoc.getText("quill");
    // Attach cursors pluginQuill.register("modules/cursors", QuillCursors);
    onMounted(() => { // Set up Quill editor and modules const quill = new Quill(element.value, { placeholder: "Start collaborating…", theme: "snow", modules: { cursors: true, toolbar: [ [{ header: [1, 2, false] }], ["bold", "italic", "underline"], ["code-block"], ], history: { // Local undo shouldn’t undo changes made by other users userOnly: true, }, }, });
    // Attach Yjs to Quill binding.value = new QuillBinding(yText, quill, yProvider.awareness);});
    onUnmounted(() => { binding?.destroy?.(); leave?.();});</script>
    <template> <div ref="element" /></template>
  4. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative Quill text editor inside your Vue.js application.